Loading...
Searching...
No Matches
elastix::OpenCLFixedGenericPyramid< TElastix > Class Template Reference
Components » ImagePyramids

`#include <elxOpenCLFixedGenericPyramid.h>`

## Detailed Description

template<class TElastix>
class elastix::OpenCLFixedGenericPyramid< TElastix >

A pyramid based on the itk::GenericMultiResolutionPyramidImageFilter. The parameters used in this class are:

Parameters

  Pyramid: Select this pyramid as follows:
  (FixedImagePyramid "OpenCLFixedGenericImagePyramid")

  Pyramid: Enable the OpenCL pyramid as follows:
  (OpenCLFixedGenericImagePyramidUseOpenCL "true")

Author
  Denis P. Shamonin and Marius Staring. Division of Image Processing, Department of Radiology, Leiden, The Netherlands

Note
  This work was funded by the Netherlands Organisation for Scientific Research (NWO NRG-2010.02 and NWO 639.021.124).

See also
  FixedGenericPyramid

Definition at line 48 of file elxOpenCLFixedGenericPyramid.h.

Inheritance diagram for elastix::OpenCLFixedGenericPyramid< TElastix >:
[legend]

## Public Types

using | ConstPointer = itk::SmartPointer<const Self>
using | GPUInputImagePointer = typename GPUInputImageType::Pointer
using | GPUInputImageType = itk::GPUImage<InputImagePixelType, InputImageType::ImageDimension>
using | GPUOutputImageType = itk::GPUImage<OutputImagePixelType, OutputImageType::ImageDimension>
using | GPUPyramidPointer = typename GPUPyramidType::Pointer
using | GPUPyramidType = itk::GenericMultiResolutionPyramidImageFilter<GPUInputImageType, GPUOutputImageType, float>
using | InputImagePixelType = typename Superclass1::InputImageType::PixelType
using | ObjectFactoryBasePointer = typename itk::ObjectFactoryBase::Pointer
using | OutputImagePixelType = typename Superclass1::OutputImageType::PixelType
using | Pointer = itk::SmartPointer<Self>
using | Self = OpenCLFixedGenericPyramid
using | Superclass = FixedGenericPyramid<TElastix>
using | Superclass1 = typename FixedGenericPyramid<TElastix>::Superclass1
using | Superclass2 = typename FixedGenericPyramid<TElastix>::Superclass2
Public Types inherited from elastix::FixedGenericPyramid< TElastix >
using | ConstPointer = itk::SmartPointer<const Self>
using | ITKBaseType = typename Superclass2::ITKBaseType
using | Pointer = itk::SmartPointer<Self>
using | Self = FixedGenericPyramid
using | Superclass1
using | Superclass2 = FixedImagePyramidBase<TElastix>
Public Types inherited from itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >
using | ConstPointer = SmartPointer<const Self>
using | Pointer = SmartPointer<Self>
using | RescaleFactorArrayType = SigmaArrayType
using | RescaleScheduleType = ScheduleType
using | ScalarRealType = typename NumericTraits<PixelType>::ScalarRealType
using | Self = GenericMultiResolutionPyramidImageFilter
using | SigmaArrayType = FixedArray<ScalarRealType, Self::ImageDimension>
using | SmoothingScheduleType = vnl_matrix<ScalarRealType>
using | SpacingType = typename Superclass::InputImageType::SpacingType
using | Superclass = MultiResolutionPyramidImageFilter<TInputImage, TOutputImage>
using | SuperSuperclass = typename Superclass::Superclass
Public Types inherited from elastix::FixedImagePyramidBase< TElastix >
using | ElastixType
using | InputImageType = typename ElastixType::FixedImageType
using | ITKBaseType = itk::MultiResolutionPyramidImageFilter<InputImageType, OutputImageType>
using | OutputImageType = typename ElastixType::FixedImageType
using | RegistrationType
using | ScheduleType = typename ITKBaseType::ScheduleType
using | Self = FixedImagePyramidBase
using | Superclass = BaseComponentSE<TElastix>
Public Types inherited from elastix::BaseComponentSE< TElastix >
using | ElastixType = TElastix
using | RegistrationType = typename ElastixType::RegistrationBaseType
using | Self = BaseComponentSE
using | Superclass = BaseComponent

## Public Member Functions

void | BeforeRegistration () override
| elxClassNameMacro ("OpenCLFixedGenericImagePyramid")
virtual const char * | GetClassName () const
| ITK_DISALLOW_COPY_AND_MOVE (OpenCLFixedGenericPyramid)
| itkStaticConstMacro (ImageDimension, unsigned int, Superclass1::ImageDimension)
virtual void | ReadFromFile ()
Public Member Functions inherited from elastix::FixedGenericPyramid< TElastix >
void | BeforeEachResolution () override
| elxClassNameMacro ("FixedGenericImagePyramid")
| ITK_DISALLOW_COPY_AND_MOVE (FixedGenericPyramid)
| itkStaticConstMacro (ImageDimension, unsigned int, Superclass1::ImageDimension)
void | SetFixedSchedule () override
Public Member Functions inherited from itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >
virtual void | ComputeOnlyForCurrentLevelOff ()
virtual void | ComputeOnlyForCurrentLevelOn ()
virtual bool | GetComputeOnlyForCurrentLevel () const
virtual const unsigned int & | GetCurrentLevel ()
const RescaleScheduleType & | GetRescaleSchedule () const
virtual const SmoothingScheduleType & | GetSmoothingSchedule ()
| ITK_DISALLOW_COPY_AND_MOVE (GenericMultiResolutionPyramidImageFilter)
| itkStaticConstMacro (ImageDimension, unsigned int, TInputImage::ImageDimension)
| itkStaticConstMacro (OutputImageDimension, unsigned int, TOutputImage::ImageDimension)
virtual void | SetComputeOnlyForCurrentLevel (const bool _arg)
virtual void | SetCurrentLevel (unsigned int level)
void | SetNumberOfLevels (unsigned int num) override
virtual void | SetRescaleSchedule (const RescaleScheduleType &schedule)
virtual void | SetRescaleScheduleToUnity ()
void | SetSchedule (const ScheduleType &schedule) override
virtual void | SetSmoothingSchedule (const SmoothingScheduleType &schedule)
virtual void | SetSmoothingScheduleToZero ()
Public Member Functions inherited from elastix::FixedImagePyramidBase< TElastix >
void | BeforeEachResolutionBase () override
void | BeforeRegistrationBase () override
ITKBaseType * | GetAsITKBaseType ()
const ITKBaseType * | GetAsITKBaseType () const
| ITK_DISALLOW_COPY_AND_MOVE (FixedImagePyramidBase)
void | WritePyramidImage (const std::string &filename, const unsigned int level)
Public Member Functions inherited from elastix::BaseComponentSE< TElastix >
void | AddTargetCellToIterationInfo (const char *const name)
const Configuration * | GetConfiguration () const
ElastixType * | GetElastix () const
auto & | GetIterationInfoAt (const char *const name)
RegistrationType * | GetRegistration () const
| ITK_DISALLOW_COPY_AND_MOVE (BaseComponentSE)
void | RemoveTargetCellFromIterationInfo (const char *const name)
void | SetConfiguration (const Configuration *_arg)
void | SetElastix (ElastixType *_arg)
Public Member Functions inherited from elastix::BaseComponent
virtual void | AfterEachIteration ()
virtual void | AfterEachIterationBase ()
virtual void | AfterEachResolution ()
virtual void | AfterEachResolutionBase ()
virtual void | AfterRegistration ()
virtual void | AfterRegistrationBase ()
virtual int | BeforeAll ()
virtual int | BeforeAllBase ()
virtual const char * | elxGetClassName () const
const char * | GetComponentLabel () const
| ITK_DISALLOW_COPY_AND_MOVE (BaseComponent)
| itkTypeMacroNoParent (BaseComponent)
void | SetComponentLabel (const char *label, unsigned int idx)

## Static Public Member Functions

static Pointer | New ()
Static Public Member Functions inherited from elastix::FixedGenericPyramid< TElastix >
static Pointer | New ()
Static Public Member Functions inherited from itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >
static Pointer | New ()
Static Public Member Functions inherited from elastix::BaseComponent
template<typename TBaseComponent>
static auto | AsITKBaseType (TBaseComponent *const baseComponent) -> decltype(baseComponent->GetAsITKBaseType())
static void | InitializeElastixExecutable ()
static bool | IsElastixLibrary ()

## Protected Member Functions

void | BeforeGenerateData ()
void | GenerateData () override
| OpenCLFixedGenericPyramid ()
| ~OpenCLFixedGenericPyramid () override=default
Protected Member Functions inherited from elastix::FixedGenericPyramid< TElastix >
| FixedGenericPyramid ()=default
| ~FixedGenericPyramid () override=default
Protected Member Functions inherited from itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >
void | GenerateData () override
void | GenerateInputRequestedRegion () override
void | GenerateOutputInformation () override
void | GenerateOutputRequestedRegion (DataObject *output) override
| GenericMultiResolutionPyramidImageFilter ()
void | PrintSelf (std::ostream &os, Indent indent) const override
void | ReleaseOutputs ()
| ~GenericMultiResolutionPyramidImageFilter () override=default
Protected Member Functions inherited from elastix::FixedImagePyramidBase< TElastix >
| FixedImagePyramidBase ()=default
| ~FixedImagePyramidBase () override=default
Protected Member Functions inherited from elastix::BaseComponentSE< TElastix >
| BaseComponentSE ()=default
| ~BaseComponentSE () override=default
Protected Member Functions inherited from elastix::BaseComponent
| BaseComponent ()=default
virtual | ~BaseComponent ()=default

## Private Member Functions

void | RegisterFactories ()
void | ReportToLog ()
void | SwitchingToCPUAndReport (const bool configError)
void | UnregisterFactories ()

## Private Attributes

| elxOverrideGetSelfMacro
bool | m_ContextCreated
std::vector< ObjectFactoryBasePointer > | m_Factories
GPUPyramidPointer | m_GPUPyramid
bool | m_GPUPyramidCreated
bool | m_GPUPyramidReady
bool | m_UseOpenCL

## Additional Inherited Members

Protected Attributes inherited from itk::GenericMultiResolutionPyramidImageFilter< TInputImage, TOutputImage, TPrecisionType >
bool | m_ComputeOnlyForCurrentLevel {}
unsigned int | m_CurrentLevel {}
SmoothingScheduleType | m_SmoothingSchedule {}
bool | m_SmoothingScheduleDefined {}
Protected Attributes inherited from elastix::BaseComponentSE< TElastix >
Configuration::ConstPointer | m_Configuration {}
itk::WeakPointer< TElastix > | m_Elastix {}
RegistrationType * | m_Registration {}

## Member Typedef Documentation

## ConstPointer

template<class TElastix>

using elastix::OpenCLFixedGenericPyramid< TElastix >::ConstPointer = itk::SmartPointer<const Self>

Definition at line 59 of file elxOpenCLFixedGenericPyramid.h.

## GPUInputImagePointer

template<class TElastix>

using elastix::OpenCLFixedGenericPyramid< TElastix >::GPUInputImagePointer = typename GPUInputImageType::Pointer

Definition at line 87 of file elxOpenCLFixedGenericPyramid.h.

## GPUInputImageType

template<class TElastix>

using elastix::OpenCLFixedGenericPyramid< TElastix >::GPUInputImageType = itk::GPUImage<InputImagePixelType, InputImageType::ImageDimension>

GPU Typedefs for GPU image and GPU filter.

Definition at line 86 of file elxOpenCLFixedGenericPyramid.h.

## GPUOutputImageType

template<class TElastix>

using elastix::OpenCLFixedGenericPyramid< TElastix >::GPUOutputImageType = itk::GPUImage<OutputImagePixelType, OutputImageType::ImageDimension>

Definition at line 88 of file elxOpenCLFixedGenericPyramid.h.

## GPUPyramidPointer

template<class TElastix>

using elastix::OpenCLFixedGenericPyramid< TElastix >::GPUPyramidPointer = typename GPUPyramidType::Pointer

Definition at line 91 of file elxOpenCLFixedGenericPyramid.h.

## GPUPyramidType

template<class TElastix>

using elastix::OpenCLFixedGenericPyramid< TElastix >::GPUPyramidType = itk::GenericMultiResolutionPyramidImageFilter<GPUInputImageType, GPUOutputImageType, float>

Definition at line 90 of file elxOpenCLFixedGenericPyramid.h.

## InputImagePixelType

template<class TElastix>

using elastix::OpenCLFixedGenericPyramid< TElastix >::InputImagePixelType = typename Superclass1::InputImageType::PixelType

Definition at line 79 of file elxOpenCLFixedGenericPyramid.h.

## ObjectFactoryBasePointer

template<class TElastix>

using elastix::OpenCLFixedGenericPyramid< TElastix >::ObjectFactoryBasePointer = typename itk::ObjectFactoryBase::Pointer

Typedefs for factory.

Definition at line 83 of file elxOpenCLFixedGenericPyramid.h.

## OutputImagePixelType

template<class TElastix>

using elastix::OpenCLFixedGenericPyramid< TElastix >::OutputImagePixelType = typename Superclass1::OutputImageType::PixelType

Definition at line 80 of file elxOpenCLFixedGenericPyramid.h.

## Pointer

template<class TElastix>

using elastix::OpenCLFixedGenericPyramid< TElastix >::Pointer = itk::SmartPointer<Self>

Definition at line 58 of file elxOpenCLFixedGenericPyramid.h.

## Self

template<class TElastix>

using elastix::OpenCLFixedGenericPyramid< TElastix >::Self = OpenCLFixedGenericPyramid

Standard ITK-stuff.

Definition at line 54 of file elxOpenCLFixedGenericPyramid.h.

## Superclass

template<class TElastix>

using elastix::OpenCLFixedGenericPyramid< TElastix >::Superclass = FixedGenericPyramid<TElastix>

Definition at line 55 of file elxOpenCLFixedGenericPyramid.h.

## Superclass1

template<class TElastix>

using elastix::OpenCLFixedGenericPyramid< TElastix >::Superclass1 = typename FixedGenericPyramid<TElastix>::Superclass1

Definition at line 56 of file elxOpenCLFixedGenericPyramid.h.

## Superclass2

template<class TElastix>

using elastix::OpenCLFixedGenericPyramid< TElastix >::Superclass2 = typename FixedGenericPyramid<TElastix>::Superclass2

Definition at line 57 of file elxOpenCLFixedGenericPyramid.h.

## Constructor & Destructor Documentation

## OpenCLFixedGenericPyramid()

template<class TElastix>

elastix::OpenCLFixedGenericPyramid< TElastix >::OpenCLFixedGenericPyramid | ( |  | ) |

protected

The constructor.

## ~OpenCLFixedGenericPyramid()

template<class TElastix>

elastix::OpenCLFixedGenericPyramid< TElastix >::~OpenCLFixedGenericPyramid | ( |  | ) |

override protected default

The destructor.

## Member Function Documentation

## BeforeGenerateData()

template<class TElastix>

void elastix::OpenCLFixedGenericPyramid< TElastix >::BeforeGenerateData | ( |  | ) |

protected

This method performs all configuration for GPU pyramid.

## BeforeRegistration()

template<class TElastix>

void elastix::OpenCLFixedGenericPyramid< TElastix >::BeforeRegistration | ( |  | ) |

override virtual

Do some things before registration.

Reimplemented from elastix::BaseComponent.

## elxClassNameMacro()

template<class TElastix>

elastix::OpenCLFixedGenericPyramid< TElastix >::elxClassNameMacro | ( | "OpenCLFixedGenericImagePyramid" |  | ) |

Name of this class. Use this name in the parameter file to select this specific pyramid.
example: (FixedImagePyramid "OpenCLFixedGenericImagePyramid")

## GenerateData()

template<class TElastix>

void elastix::OpenCLFixedGenericPyramid< TElastix >::GenerateData | ( |  | ) |

override protected

Executes GPU pyramid.

## GetClassName()

template<class TElastix>

virtual const char * elastix::OpenCLFixedGenericPyramid< TElastix >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from elastix::FixedGenericPyramid< TElastix >.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TElastix>

elastix::OpenCLFixedGenericPyramid< TElastix >::ITK_DISALLOW_COPY_AND_MOVE | ( | OpenCLFixedGenericPyramid< TElastix > |  | ) |

## itkStaticConstMacro()

template<class TElastix>

elastix::OpenCLFixedGenericPyramid< TElastix >::itkStaticConstMacro | ( | ImageDimension | ,
|  | unsigned int | ,
|  | Superclass1::ImageDimension | )

Get the ImageDimension.

## New()

template<class TElastix>

Pointer elastix::OpenCLFixedGenericPyramid< TElastix >::New | ( |  | ) |

static

Method for creation through the object factory.

## ReadFromFile()

template<class TElastix>

virtual void elastix::OpenCLFixedGenericPyramid< TElastix >::ReadFromFile | ( |  | ) |

virtual

Function to read parameters from a file.

## RegisterFactories()

template<class TElastix>

void elastix::OpenCLFixedGenericPyramid< TElastix >::RegisterFactories | ( |  | ) |

private

Register/Unregister factories.

## ReportToLog()

template<class TElastix>

void elastix::OpenCLFixedGenericPyramid< TElastix >::ReportToLog | ( |  | ) |

private

Helper method to report to elastix log.

## SwitchingToCPUAndReport()

template<class TElastix>

void elastix::OpenCLFixedGenericPyramid< TElastix >::SwitchingToCPUAndReport | ( | const bool | configError | ) |

private

Helper method to report switching to CPU mode.

## UnregisterFactories()

template<class TElastix>

void elastix::OpenCLFixedGenericPyramid< TElastix >::UnregisterFactories | ( |  | ) |

private

## Field Documentation

## elxOverrideGetSelfMacro

template<class TElastix>

elastix::OpenCLFixedGenericPyramid< TElastix >::elxOverrideGetSelfMacro

private

Definition at line 116 of file elxOpenCLFixedGenericPyramid.h.

## m_ContextCreated

template<class TElastix>

bool elastix::OpenCLFixedGenericPyramid< TElastix >::m_ContextCreated

private

Definition at line 136 of file elxOpenCLFixedGenericPyramid.h.

## m_Factories

template<class TElastix>

std::vector<ObjectFactoryBasePointer> elastix::OpenCLFixedGenericPyramid< TElastix >::m_Factories

private

Definition at line 138 of file elxOpenCLFixedGenericPyramid.h.

## m_GPUPyramid

template<class TElastix>

GPUPyramidPointer elastix::OpenCLFixedGenericPyramid< TElastix >::m_GPUPyramid

private

Definition at line 133 of file elxOpenCLFixedGenericPyramid.h.

## m_GPUPyramidCreated

template<class TElastix>

bool elastix::OpenCLFixedGenericPyramid< TElastix >::m_GPUPyramidCreated

private

Definition at line 135 of file elxOpenCLFixedGenericPyramid.h.

## m_GPUPyramidReady

template<class TElastix>

bool elastix::OpenCLFixedGenericPyramid< TElastix >::m_GPUPyramidReady

private

Definition at line 134 of file elxOpenCLFixedGenericPyramid.h.

## m_UseOpenCL

template<class TElastix>

bool elastix::OpenCLFixedGenericPyramid< TElastix >::m_UseOpenCL

private

Definition at line 137 of file elxOpenCLFixedGenericPyramid.h.

Generated on 1768596610 for elastix by 1.15.0 |